﻿import serial
import time
import requests
import json
import urllib

# Thiết lập kết nối http cho JSON-PRC
# Cần phải có header cho XBMC JSON-RPC calls, nếu không bạn sẽ nhận được lỗi 
#415 HTTP response code - Unsupported media type
headers = {'content-type': 'application/json'}
 
#Host name của máy chạy XBMC, để là localhost nếu chạy trên máy hiện tại
#Hãy chắc chắn rằng "Allow control of XBMC via HTTP" được đặt là ON trong Settings -> 
#Services -> Webserver
xbmc_host = '192.168.0.100'
 
#Con số này lấy trong Settings -> Services -> Webserver -> Port của XBMC
xbmc_port = 8080
#Base URL of the json RPC calls. For GET calls we append a "request" URI 
#parameter. For POSTs, we add the payload as JSON the the HTTP request body
xbmc_json_rpc_url = "http://" + xbmc_host + ":" + str(xbmc_port) + "/jsonrpc"

#//Hết phần thiết lập kết nối http cho JSON-PRC

# Gán các nút trên vô lăng, phần này cần điều chỉnh cụ thể cho từng xe ô tô
up="len"
down= "xuong"
right="phai"
left="trai"
select="chon"
back="quay"
play="phat"
home="home"
shuthdown="tat"
volup="vu"
voldown="vd"
# //Hết đoạn mã Gán các nút trên vô lăng

# Thiết lập cổng kết nối serial, trong đó "/dev/ttyAMA0" baudrate=115200 phải 
# điều chỉnh chính xác theo từng trường hợp cụ thể. 
# Đọc ebook http://tranhchuthap.vn/bai-viet/canbus/Hack-CAN-BUS-Dieu-khien-volang.pdf 
# để biết thêm chi tiết
	
#port = serial.Serial("/dev/ttyAMA0", baudrate=115200, timeout=3.0)

# Kiểm tra xem OBDII đã kết nối tới Rasperry Pi chưa, nếu chưa chờ 5s rồi 
# kiểm tra lại, khi nào có kết nối mới thực hiện các công việc tiếp theo
#while (port.isOpen() == False):
#    print("chua ket noi OBDII toi Raspberry Pi!")
#	time.sleep(5)
	

# Gửi lệnh dump CANBUS để đọc tất cả các message trên mạng CAN. 
# Tuy nhiên nếu đã biết ID của vô lăng thì có thể chỉ dump các 
# mesage có ID đó để cho công việc này trở nên đơn giản và nhẹ nhàng

#port.write("ATL1\r")	# Bật Line feed, nghĩa là cứ mỗi một khung truyền được tạo thành một dòng trên màn hình kết quả
#port.write("ATH1\r")	# Bật Header để xem ID của các tin nhắn, nhìn vào ID có thể luận ra tin nhắn đó do bộ phận nào trên xe gửi và gửi cho bộ phận nào
#port.write("ATSP0\r")	# Thiết lập giao thức (protocol) về tự động. Nếu biết cụ thể xe dùng giao thức nào thì tốt nhất chỉnh cố định thay vì tự động. Trong Hack-CAN-BUS-Dieu-khien-volang.pdf đã nói rõ về việc này
#port.write("ATS1\r")	# Bật khoảng trống giữa các byte để kết quả dễ nhìn. Ví dụ 1A 2B 13 4F thay vì 1A2B134F. Cái này ko thích có thể bỏ qua
#port.write("ATAL\r")	
#port.write("ATMA\r")	# Lệnh này dump toàn bộ các message trên mạng canbus và gửi ra RaspBerry Pi, nếu biết ID của vô lăng có thể dump riêng chỉ những ID của vô lăng

#if port.isOpen():
    #print("serial is open!")
#def readlineCR(port):
#    rv = ""
#    while True:
#        ch = port.read()
#        rv += ch
#        if ch=='\r' or ch=='':
#            return rv
			
# Lặp đi lặp lại việc: Đọc giá trị từ cổng serial -> kiểm tra xem giá trị nhận được giống với mã của nút nào 
# trên vô lăng thì thực hiện việc gửi lệnh điều khiển do mình đặt tới XBMC qua JSON-RPC	

while True: 
    #rcv = readlineCR(port)
    rcv = raw_input('Nhap lenh:')
    #rcv=""+rcv1+""
# //Kiem tra xem co file nao dang play khong
    if (rcv == up):
        payload = {"jsonrpc": "2.0", "method": "Input.Up", "id": 1}
        response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)
    elif (rcv == down):
        payload = {"jsonrpc": "2.0", "method": "Input.Down", "id": 1}
        response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)
    elif (rcv == right):
        payload = {"jsonrpc": "2.0", "method": "Input.Right", "id": 1}
        response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)
    elif (rcv == left):
        payload = {"jsonrpc": "2.0", "method": "Input.Left", "id": 1}
        response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)
    elif (rcv == select):
        payload = {"jsonrpc": "2.0", "method": "Input.Select", "id": 1}
        response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)
    elif (rcv == home):
        payload = {"jsonrpc": "2.0", "method": "Input.Home", "id": 1}
        response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)
    elif (rcv == shuthdown):
        payload = {"jsonrpc": "2.0", "method": "System.Shutdown", "id": 1}
        response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)
    elif (rcv == volup):
        payload = {"jsonrpc": "2.0", "method": "Application.SetVolume", "params": { "volume": "increment" }, "id": 1}
        response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)
    elif (rcv == voldown):
        payload = {"jsonrpc": "2.0", "method": "Application.SetVolume", "params": { "volume": "decrement" }, "id": 1}
    elif (rcv == back):
        payload = {"jsonrpc": "2.0", "method": "Input.Back", "id": 1}
        response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)          
    elif (rcv == play):
        #Payload for the method to get the currently playing / paused video or audio
        payload = {"jsonrpc": "2.0", "method": "Player.GetActivePlayers", "id": 1}
        url_param = urllib.urlencode({'request': json.dumps(payload)})
        response = requests.get(xbmc_json_rpc_url + '?' + url_param, headers=headers)
        #response.text will look like this if something is playing
        #{"id":1,"jsonrpc":"2.0","result":[{"playerid":1,"type":"video"}]}
        #and if nothing is playing:
        #{"id":1,"jsonrpc":"2.0","result":[]}
        data = json.loads(response.text)
        #result is an empty list if nothing is playing or paused. 
        if data['result']:
           #We need the specific "playerid" of the currently playing file in order 
           #to pause it
           player_id = data['result'][0]["playerid"]
           payload = {"jsonrpc": "2.0", "method": "Player.PlayPause","params": {"playerid": player_id }, "id": 1}
           response = requests.post(xbmc_json_rpc_url, data=json.dumps(payload),headers=headers)
           #response.text will look like this if we're successful:
           #{"id":1,"jsonrpc":"2.0","result":{"speed":0}}
    else:
        time.sleep(0.1)
	
